import { Attributes } from "graphology-types";
import { EdgeDisplayData, NodeDisplayData } from "../../../types.js";
import EdgeRectangleProgram from "../edge-rectangle/index.js";
export default class EdgeClampedProgram<N extends Attributes, E extends Attributes, G extends Attributes> extends EdgeRectangleProgram<N, E, G> {
    getDefinition(): {
        VERTEX_SHADER_SOURCE: string;
        ATTRIBUTES: ({
            name: string;
            size: number;
            type: 5126;
            normalized?: undefined;
        } | {
            name: string;
            size: number;
            type: 5121;
            normalized: boolean;
        })[];
        CONSTANT_ATTRIBUTES: {
            name: string;
            size: number;
            type: 5126;
        }[];
        CONSTANT_DATA: number[][];
        VERTICES: number;
        FRAGMENT_SHADER_SOURCE: string;
        METHOD: 4;
        UNIFORMS: readonly ["u_matrix", "u_zoomRatio", "u_sizeRatio", "u_correctionRatio"];
    };
    processVisibleItem(edgeIndex: number, startIndex: number, sourceData: NodeDisplayData, targetData: NodeDisplayData, data: EdgeDisplayData): void;
}
